File: try.sh
   1 #!/bin/sh
   2 
   3 # The MIT License (MIT)
   4 #
   5 # Copyright (c) 2026 pacman64
   6 #
   7 # Permission is hereby granted, free of charge, to any person obtaining a copy
   8 # of this software and associated documentation files (the "Software"), to deal
   9 # in the Software without restriction, including without limitation the rights
  10 # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  11 # copies of the Software, and to permit persons to whom the Software is
  12 # furnished to do so, subject to the following conditions:
  13 #
  14 # The above copyright notice and this permission notice shall be included in
  15 # all copies or substantial portions of the Software.
  16 #
  17 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  18 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  19 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  20 # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  21 # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  22 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  23 # SOFTWARE.
  24 
  25 
  26 # try [options...] [command...] [arguments...]
  27 #
  28 # Try running a command, emitting an explicit message to standard-error if
  29 # the command given fails.
  30 #
  31 # When variable NO_COLOR is declared and set to 1, an invert/highlight style
  32 # is used instead of colors, when running the command given failed.
  33 #
  34 # The extra options are, available both in single and double-dash versions
  35 #
  36 #   -h, -help    show this help message
  37 
  38 
  39 case "$1" in
  40     -h|--h|-help|--help)
  41         awk '/^# +try /, /^$/ { gsub(/^# ?/, ""); print }' "$0"
  42         exit 0
  43     ;;
  44 
  45     --) shift ;;
  46 
  47     -*)
  48         printf "unsupported option '%s'\n" "$1" >&2
  49         exit 1
  50     ;;
  51 esac
  52 
  53 if [ $# -eq 0 ]; then
  54     awk '/^# +try /, /^$/ { gsub(/^# ?/, ""); print }' "$0"
  55     exit 0
  56 fi
  57 
  58 "$@"
  59 code=$?
  60 
  61 # show nothing and quit, on success
  62 if [ "${code}" -eq 0 ]; then
  63     exit 0
  64 fi
  65 
  66 if [ "${NO_COLOR}" = 1 ]; then
  67     printf "\n%s \033[7m failed with error code %d \033[0m\n" "$*" "${code}" >&2
  68 else
  69     printf "\n\033[38;2;204;0;0m%s \033[48;2;204;0;0m\033[38;2;255;255;255m failed with error code %d \033[0m\n" "$*" "${code}" >&2
  70 fi
  71 
  72 exit "${code}"